/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the CreateDocumentWebhookDocument type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateDocumentWebhookDocument{}

// CreateDocumentWebhookDocument struct for CreateDocumentWebhookDocument
type CreateDocumentWebhookDocument struct {
	Name string `json:"name"`
	FileUrl string `json:"file_url"`
}

// NewCreateDocumentWebhookDocument instantiates a new CreateDocumentWebhookDocument object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateDocumentWebhookDocument(name string, fileUrl string) *CreateDocumentWebhookDocument {
	this := CreateDocumentWebhookDocument{}
	this.Name = name
	this.FileUrl = fileUrl
	return &this
}

// NewCreateDocumentWebhookDocumentWithDefaults instantiates a new CreateDocumentWebhookDocument object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateDocumentWebhookDocumentWithDefaults() *CreateDocumentWebhookDocument {
	this := CreateDocumentWebhookDocument{}
	return &this
}

// GetName returns the Name field value
func (o *CreateDocumentWebhookDocument) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CreateDocumentWebhookDocument) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CreateDocumentWebhookDocument) SetName(v string) {
	o.Name = v
}

// GetFileUrl returns the FileUrl field value
func (o *CreateDocumentWebhookDocument) GetFileUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.FileUrl
}

// GetFileUrlOk returns a tuple with the FileUrl field value
// and a boolean to check if the value has been set.
func (o *CreateDocumentWebhookDocument) GetFileUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.FileUrl, true
}

// SetFileUrl sets field value
func (o *CreateDocumentWebhookDocument) SetFileUrl(v string) {
	o.FileUrl = v
}

func (o CreateDocumentWebhookDocument) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateDocumentWebhookDocument) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["file_url"] = o.FileUrl
	return toSerialize, nil
}

type NullableCreateDocumentWebhookDocument struct {
	value *CreateDocumentWebhookDocument
	isSet bool
}

func (v NullableCreateDocumentWebhookDocument) Get() *CreateDocumentWebhookDocument {
	return v.value
}

func (v *NullableCreateDocumentWebhookDocument) Set(val *CreateDocumentWebhookDocument) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateDocumentWebhookDocument) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateDocumentWebhookDocument) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateDocumentWebhookDocument(val *CreateDocumentWebhookDocument) *NullableCreateDocumentWebhookDocument {
	return &NullableCreateDocumentWebhookDocument{value: val, isSet: true}
}

func (v NullableCreateDocumentWebhookDocument) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateDocumentWebhookDocument) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


